(define gegenstaende
  (list->vector
   '("dummy"
     (13 . 19)
     (11 . 20)
     (17 . 23)
     (15 . 21)
     (16 . 27)
     (14 . 25)
     (18 . 25)
     (10 . 18)
     (19 . 24)
     (12 . 17))))

(define gewicht
  (lambda (i)
    (car (vector-ref gegenstaende i))))

(define wert
  (lambda (i)
    (cdr (vector-ref gegenstaende i))))
(define gesamtwert-rekursiv
  (lambda (n k)
    (let ((rek-aufrufe 0))
      (letrec
          ((gesamtwert
            (lambda (i g)
              (set! rek-aufrufe (+ rek-aufrufe 1))
              (cond
                ((= i 0) 0)
                ((> (gewicht i) g) (gesamtwert (- i 1) g))
                (else
                 (max
                  (gesamtwert (- i 1) g)
                  (+ (gesamtwert (- i 1) (- g (gewicht i)))(wert i))))))))
        (list (gesamtwert n k) rek-aufrufe)))))

(define gesamtwert-rekursiv-memo
  (let ((memoliste '())) ; neu
    (lambda (n k)
      (let ((rek-aufrufe 0))
	(letrec
	    ((gesamtwert-memo   ; neu
	      (lambda (i g)
		(let ((memowert (assoc (cons i g) memoliste)))
		  (if memowert
		      (cdr memowert)
		      (let ((resultat (gesamtwert i g)))
			(set! memoliste
                              (cons (cons (cons i g) resultat) memoliste))
			resultat)))))
	     (gesamtwert
	      (lambda (i g)
		(set! rek-aufrufe (+ rek-aufrufe 1)) ; mit WertNEUberechnung
		(cond
                  ((= i 0) 0)
		  ((> (gewicht i) g) (gesamtwert-memo (- i 1) g))  ; modifiziert
		  (else
                   (max
                    (gesamtwert-memo (- i 1) g) ; modifiziert
                    (+ (gesamtwert-memo (- i 1) (- g (gewicht i)))(wert i))))))))
	  (list (gesamtwert n k) rek-aufrufe (length memoliste)))))))


